--- linux-2.6.15.4-mips/arch/mips/vsc452/time.c	1969-12-31 19:00:00.000000000 -0500
+++ linux-2.6.15.4-mips-vsc452/arch/mips/vsc452/time.c	2008-08-25 10:39:11.971178398 -0400
@@ -0,0 +1,63 @@
+/*
+ * Carsten Langgaard, carstenl@mips.com
+ * Copyright (C) 1999,2000 MIPS Technologies, Inc.  All rights reserved.
+ *
+ *  This program is free software; you can distribute it and/or modify it
+ *  under the terms of the GNU General Public License (Version 2) as
+ *  published by the Free Software Foundation.
+ *
+ *  This program is distributed in the hope it will be useful, but WITHOUT
+ *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ *  for more details.
+ *
+ *  You should have received a copy of the GNU General Public License along
+ *  with this program; if not, write to the Free Software Foundation, Inc.,
+ *  59 Temple Place - Suite 330, Boston MA 02111-1307, USA.
+ *
+ * Setting up the clock on the MIPS boards.
+ */
+
+#include <linux/types.h>
+#include <linux/init.h>
+#include <linux/interrupt.h>
+#include <linux/irq.h>
+#include <asm/mach-vsc452/vsc452.h>
+#include <asm/i8253.h>
+#include <asm/time.h>
+
+unsigned long cpu_khz;
+
+static int mips_cpu_perf_irq;
+extern int cp0_perfcount_irq;
+
+void __init mips_timer_setup(struct irqaction *irq)
+{
+	u32 mips_cpu_timer_irq = MIPSCPU_INT_BASE + MIPSCPU_INT_CPUCTR;
+       irq->flags |= IRQF_SHARED;
+	setup_irq(mips_cpu_timer_irq, irq);
+} 
+
+static void mips_perf_dispatch(void)
+{
+        do_IRQ(mips_cpu_perf_irq);
+}
+
+static void __init plat_perf_setup(void)
+{
+    if (cp0_perfcount_irq >= 0) {
+            if (cpu_has_vint)
+		{
+                   set_vi_handler(cp0_perfcount_irq, mips_perf_dispatch);
+		}
+             mips_cpu_perf_irq = MIPS_CPU_IRQ_BASE + cp0_perfcount_irq;
+	}
+}
+
+void __init plat_time_init(void)
+{
+        // clocked @ 300MHz, counter counts every other clock
+        mips_hpt_frequency = 300e6/2;
+	cpu_khz= mips_hpt_frequency/1000;
+	plat_perf_setup();
+}
